'' PROPMAN By Jeff Ledger / OBC
'' Thanks to Jim Bagley & Peter Jakacki for graphics base.
'' ****************************  Version: 1.1a non-playable

CON

'{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000
'}

{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x                            '
  _xinfreq = 5_000_000
  modepins = %001_0101
'}

{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000
'}

PAL=%0001
NTSC=%0000
INTERLACED=%0010

x_tiles = 8 '*16=256            ' 128 bytes/line
y_tiles = 12 '*16=192
mode = 0
my_hx = 22+((mode&1)<<1)

x_pixels = x_tiles*16
y_pixels = y_tiles*16

bcnt = 128*191
clockfreq = ((_CLKMODE - XTAL1) >> 6) * _XINFREQ
_1mS  = clockfreq /     1_000 'Divisor for  1mS

  maxSprites    = 8
  maxYSZ        = 16
  maxXSZ        = 4
  spriteSZ      = maxYSZ*maxXSZ

OBJ
  tv    : "JB_TV_AMS_01"
  font  : "Font_ATARI"
  
VAR
  long  frame

'  byte  Sprites[16*maxYSZ*maxSprites]
  byte  Shadows[16*maxYSZ*maxSprites]

'  byte  SpriteXSZ[maxSprites]
'  byte  SpriteYSZ[maxSprites]
  byte  shadowX[maxSprites]
  byte  shadowY[maxSprites]
  byte  ix[8],iy[8],ii[8],spritemode[maxSprites]

  byte  dot[100]
  
PUB Main | i,demonstration

  tv.start(@tvparams)
  frame~
  
'  MakeSprite(0,87,6,8,9)  'Grab Ghost 0
'  MakeSprite(1,94,6,7,9)  'Grab Ghost 1
'  MakeSprite(2,100,6,7,9) 'Grab Ghost 2
'  MakeSprite(3,106,6,7,9) 'Grab Ghost 3


'  MakeSprite(4,93,20,6,8) 'Grab PROPMAN face right
'  MakeSprite(5,106,20,6,8) 'Grab PROPMAN Ball

'  fatprint(string("HELLO 0123456789"),0,0)   
  'DrawSprite(5,230,50) 'test zone

  print(string("#"),76,18,1,-1) 'draw top right power pellet
  print(string("#"),3,18,1,-1)  'draw top left power pellet
  print(string("#"),76,135,1,-1)'draw bottom right power pellet
  print(string("#"),3,135,1,-1) 'draw bottom left power pellet

  print(string("PROP"),89,140,34,-1)
  print(string("MAN"),93,150,34,-1)

  print(string(":OBC:"),85,170,7,-1)

  repeat until i == 99
    dot[i]:=1
    updateDOTS(i)
    i++

  repeat

    demonstration:=40
    RestoreShadow(4)
    SaveShadow(4,demonstration,135)
    propman(demonstration,135)
    Vsync
    repeat until demonstration == 62
      Vsync

      RestoreShadow(0)
      RestoreShadow(1)
      RestoreShadow(2)
      RestoreShadow(3)
      RestoreShadow(4)

      eatdot(demonstration,135)

      SaveShadow(0,36,82)
      SaveShadow(1,38,82)
      SaveShadow(2,42,82)
      SaveShadow(3,46,82)
      SaveShadow(4,demonstration,135)

      Ghosts
      propman(demonstration,135)
      demonstration++
      
pub propman (px,py)
    '
'    ms(5)
    DrawSprite(4,px,py)
'    Vsync

pub eatdot (px,py) : cdot
    px:=px+2

    case py
     135:
      if px == 44
         cdot:=65
      if px == 52
         cdot:=66
      if px == 61
         cdot:=67
      if px == 68
         cdot:=68
      if px == 10
         cdot:=61
      if px == 18
         cdot:=62
      if px == 26
         cdot:=63
      if px == 34      
         cdot:=64
  
     8:
      if px == 2
         cdot:=1       
      if px == 10
         cdot:=2
      if px == 18
         cdot:=3
      if px == 26
         cdot:=4
      if px == 34
         cdot:=5
      if px == 44
         cdot:=6
      if px == 52
         cdot:=7
      if px == 61
         cdot:=8
      if px == 68
         cdot:=9
      if px == 75
         cdot:=10
     19:
      if px == 18
         cdot:=11
      if px == 34
         cdot:=12
      if px == 44
         cdot:=13
      if px == 61
         cdot:=14
     30:
      if px == 2
         cdot:=15
      if px == 10
         cdot:=16
      if px == 18
         cdot:=17
      if px == 26
         cdot:=18
      if px == 34
         cdot:=19
      if px == 44
         cdot:=20
      if px == 52
         cdot:=21
      if px == 61
         cdot:=22
      if px == 68
         cdot:=23
      if px == 75
         cdot:=24
     40: 
      if px == 2
         cdot:=25
      if px == 18
         cdot:=26
      if px == 26
         cdot:=27
      if px == 52
         cdot:=28
      if px == 61
         cdot:=29
      if px == 75
         cdot:=30
     50:
      if px == 2
         cdot:=31
      if px == 10
         cdot:=32
      if px == 18
         cdot:=33
      if px == 26
         cdot:=34
      if px == 34
         cdot:=35
      if px == 44
         cdot:=36
      if px == 52
         cdot:=37
      if px == 61
         cdot:=38
      if px == 68
         cdot:=39
      if px == 75
         cdot:=40
     61:
      if px == 18
         cdot:=41
      if px == 61
         cdot:=42
     71:
      if px == 18
         cdot:=43
      if px == 61
         cdot:=44
     82:
      if px == 18
         cdot:=45
      if px == 61
         cdot:=46
     94:
      if px == 18
         cdot:=47
      if px == 61
         cdot:=48
     105:
      if px == 18
         cdot:=49
      if px == 61
         cdot:=50
     120:
      if px == 2
         cdot:=51
      if px == 10
         cdot:=52
      if px == 18
         cdot:=53
      if px == 26
         cdot:=54
      if px == 34
         cdot:=55
      if px == 44
         cdot:=56
      if px == 52
         cdot:=57
      if px == 61
         cdot:=58
      if px == 68
         cdot:=59
      if px == 75
         cdot:=60
     145:
      if px == 10
         cdot:=69
      if px == 18
         cdot:=70
      if px == 26
         cdot:=71
      if px == 52
         cdot:=72
      if px == 61
         cdot:=73
      if px == 68
         cdot:=74

     155:
      if px == 2
         cdot:=75
      if px == 10
         cdot:=76
      if px == 18
         cdot:=77
      if px == 26
         cdot:=78
      if px == 34
         cdot:=79
      if px == 44
         cdot:=80
      if px == 52
         cdot:=81
      if px == 61
         cdot:=82
      if px == 68
         cdot:=83
      if px == 75
         cdot:=84

     170:
      if px == 2
         cdot:=85
      if px == 10
         cdot:=86
      if px == 18
         cdot:=87
      if px == 26
         cdot:=88
      if px == 34
         cdot:=89
      if px == 44
         cdot:=90
      if px == 52
         cdot:=91
      if px == 61
         cdot:=92
      if px == 68
         cdot:=93
      if px == 75
         cdot:=94
         
    dot[cdot]:=0
    updateDots(cdot)
    


PUB UpdateDOTS(dotpos)

  'Top Row
 CASE dotpos
  1..5: print(string("."),2,8,dot[1],-1) '                         #1
        print(string("."),10,8,dot[2],-1)'                         #2
        print(string("."),18,8,dot[3],-1)'18 is row 1              #3
        print(string("."),26,8,dot[4],-1)'                         #4
        print(string("."),34,8,dot[5],-1)'34 is row 2              #5
  6..10:print(string("."),44,8,dot[6],-1)'44 is row 3              #6
        print(string("."),52,8,dot[7],-1)'                         #7
        print(string("."),61,8,dot[8],-1)'61 is row 4              #8
        print(string("."),68,8,dot[9],-1)'                         #9
        print(string("."),75,8,dot[10],-1)'75 is row 5             #10

  '2nd row
  11..14:print(string("."),18,19,dot[11],-1)'                        #11
         print(string("."),34,19,dot[12],-1)'                        #12
         print(string("."),44,19,dot[13],-1)'                        #13
         print(string("."),61,19,dot[14],-1)'                        #14

  '3rd Row
  15..20:print(string("."),2,30,dot[15],-1)'                         #15
         print(string("."),10,30,dot[16],-1)'                        #16
         print(string("."),18,30,dot[17],-1)'18 is row 1             #17
         print(string("."),26,30,dot[18],-1)'                        #18
         print(string("."),34,30,dot[19],-1)'34 is row 2             #19
         print(string("."),44,30,dot[20],-1)'44 is row 3             #20
  21..24:print(string("."),52,30,dot[21],-1)'                        #21
         print(string("."),61,30,dot[22],-1)'61 is row 4             #22
         print(string("."),68,30,dot[23],-1)'                        #23
         print(string("."),75,30,dot[24],-1)'75 is row 5             #24

   '4rd Row
  25:print(string("."),2,40,dot[25],-1)'                         #25
  26:print(string("."),18,40,dot[26],-1)'18 is row 1             #26
  27:print(string("."),26,40,dot[27],-1)'                        #27
  28:print(string("."),52,40,dot[28],-1)'                        #28
  29:print(string("."),61,40,dot[29],-1)'61 is row 4             #29
  30:print(string("."),75,40,dot[30],-1)'75 is row 5             #30

   '5rd Row
  31:print(string("."),2,50,dot[31],-1)'                         #31
  32:print(string("."),10,50,dot[32],-1)'                        #32
  33:print(string("."),18,50,dot[33],-1)'18 is row 1             #33
  34:print(string("."),26,50,dot[34],-1)'                        #34
  35:print(string("."),34,50,dot[35],-1)'34 is row 2             #35
  36:print(string("."),44,50,dot[36],-1)'44 is row 3             #36
  37:print(string("."),52,50,dot[37],-1)'                        #37
  38:print(string("."),61,50,dot[38],-1)'61 is row 4             #38
  39:print(string("."),68,50,dot[39],-1)'                        #39
  40:print(string("."),75,50,dot[40],-1)'75 is row 5             #40

  'Middle
  41:print(string("."),18,61,dot[41],-1)'                        #41
  42:print(string("."),61,61,dot[42],-1)'                        #42
  43:print(string("."),18,71,dot[43],-1)'                        #43
  44:print(string("."),61,71,dot[44],-1)'                        #44
  45:print(string("."),18,82,dot[45],-1)'                        #45
  46:print(string("."),61,82,dot[46],-1)'                        #46
  47:print(string("."),18,94,dot[47],-1)'                        #47
  48:print(string("."),61,94,dot[48],-1)'                        #48
  49:print(string("."),18,105,dot[49],-1)'                       #49
  50:print(string("."),61,105,dot[50],-1)'                       #50

  'bottom row 1
  51:print(string("."),2,120,dot[51],-1)'                        #51
  52:print(string("."),10,120,dot[52],-1)'                       #52
  53:print(string("."),18,120,dot[53],-1)'18 is row 1            #53
  54:print(string("."),26,120,dot[54],-1)'                       #54
  55:print(string("."),34,120,dot[55],-1)'34 is row 2            #55
  56:print(string("."),44,120,dot[56],-1)'44 is row 3            #56
  57:print(string("."),52,120,dot[57],-1)'                       #57
  58:print(string("."),61,120,dot[58],-1)'61 is row 4            #58
  59:print(string("."),68,120,dot[59],-1)'                       #59
  60:print(string("."),75,120,dot[60],-1)'75 is row 5            #60

  61..65:print(string("."),10,135,dot[61],-1)'                       #61
         print(string("."),18,135,dot[62],-1)'18 is row 1            #62
         print(string("."),26,135,dot[63],-1)'                       #63
         print(string("."),34,135,dot[64],-1)'34 is row 2            #64
  66..68:print(string("."),44,135,dot[65],-1)'44 is row 3            #65
        print(string("."),52,135,dot[66],-1)'                       #66
        print(string("."),61,135,dot[67],-1)'61 is row 4            #67
        print(string("."),68,135,dot[68],-1)'                       #68


  69..74:print(string("."),10,145,dot[69],-1)'                       #69
          print(string("."),18,145,dot[70],-1)'18 is row 1            #70
          print(string("."),26,145,dot[71],-1)'                       #71
          print(string("."),52,145,dot[72],-1)'                       #72
          print(string("."),61,145,dot[73],-1)'61 is row 4            #73
          print(string("."),68,145,dot[74],-1)'                       #74

  75..80:print(string("."),2,155,dot[75],-1)'                        #75
         print(string("."),10,155,dot[76],-1)'                       #76
         print(string("."),18,155,dot[77],-1)'18 is row 1            #77
         print(string("."),26,155,dot[78],-1)'                       #78
         print(string("."),34,155,dot[79],-1)'34 is row 2            #79
         print(string("."),44,155,dot[80],-1)'44 is row 3            #80
  81..84:print(string("."),52,155,dot[81],-1)'                       #81
         print(string("."),61,155,dot[82],-1)'61 is row 4            #82
         print(string("."),68,155,dot[83],-1)'                       #83
         print(string("."),75,155,dot[84],-1)'75 is row 5            #84

  85..89:print(string("."),2,170,dot[85],-1)'                        #85
         print(string("."),10,170,dot[86],-1)'                       #86
         print(string("."),18,170,dot[87],-1)'18 is row 1            #87
         print(string("."),26,170,dot[88],-1)'                       #88
         print(string("."),34,170,dot[89],-1)'34 is row 2            #89
  90..94:print(string("."),44,170,dot[90],-1)'44 is row 3            #90
         print(string("."),52,170,dot[91],-1)'                       #91
         print(string("."),61,170,dot[92],-1)'61 is row 4            #92
         print(string("."),68,170,dot[93],-1)'                       #93
         print(string("."),75,170,dot[94],-1)'75 is row 5            #94
Vsync
PUB Ghosts
 DrawSprite(0,36,82)
 DrawSprite(1,38,82)
 DrawSprite(2,42,82)
 DrawSprite(3,46,82)

pub MakeSprite(n,x,y,xsz,ysz) | i
  spriteXSZ[n] := xsz           ' save size properties
  spriteYSZ[n] := ysz
  repeat i from 0 to ysz        ' Q&D screen area grab to sprite table
     bytemove(@sprites[(n*spriteSZ)+(i*maxXSZ)], @data+(x>>1)+((y+i)<<6), xsz>>1)

pub CopySprite(dst,src)
  bytemove(@sprites[dst*spriteSZ],@sprites[src*spriteSZ],spriteSZ)
  spriteXSZ[dst] := spriteXSZ[src]
  spriteYSZ[dst] := spriteYSZ[src]

pub DrawSprite(n,x,y) | i
  if spriteXSZ[n] AND spriteYSZ[n]
    x &= 127                      ' wrap any X given as it may be incrementing past the right side
    repeat i from 0 to spriteYSZ[n] ' Q&D screen area write from sprite table
      if spritemode[n] & 1
        bytefill(screen(x,y+i), $11+i+(i<<4), spriteXSZ[n]>>1)
      else
        bytemove(screen(x,y+i), @sprites[(n*spriteSZ)+(i*maxXSZ)], spriteXSZ[n]>>1)                     'Changed i*maxYSZ to i*maxXSZ as that's the length per scanline of sprite


pub SaveShadow(n,x,y) | i,p
  shadowX[n] := x               ' remember the position of the shadow for later restoration
  shadowY[n] := y
  p := n*spriteSZ               ' speed things up a bit and remember sprite table address
  repeat i from 0 to spriteYSZ[n]
     bytemove(@shadows[p+(i*maxXSZ)], screen(x,y+i), spriteXSZ[n]>>1)

pub RestoreShadow(n) | i,p
  if shadowx[n] + shadowy[n]    ' another Q&D to prevent restore the first time the sprite is drawn
    p := n*spriteSZ
    repeat i from 0 to spriteYSZ[n]
       bytemove(screen(shadowX[n], shadowY[n]+i), @shadows[p+(i*maxXSZ)], spriteXSZ[n]>>1)


' full screen synchronized drawing

pub DrawSprites | i
'  RestoreScreen
  SaveShadows
  repeat i from maxSprites-1 to 0        ' update the sprites in priority - 0 = top
    DrawSprite(i,ix[i],iy[i])

pub SaveShadows | i
  repeat i from 0 to maxSprites-1        ' update the sprites
    SaveShadow(i,ix[i],iy[i])


pub RestoreScreen | i           ' part of the "draw em all, restore them all" plan for later
  repeat i from 0 to maxSprites-1
    RestoreShadow(i)


pub Collided(sprite1,sprite2)
  if ix[sprite1] => ix[sprite2] and ix[sprite1] =< ix[sprite2]+spriteXSZ[sprite2]
    if iy[sprite1] => iy[sprite2] and iy[sprite1] =< iy[sprite2]+spriteYSZ[sprite2]
      result := true


pub screen(x,y)                 ' point to the screen memory which consists of 2 pixels/byte, 64 bytes/line
  result := @data+(x>>1)+(y<<6)


PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$f0)+c
  else
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$0f)+(c<<4)



PUB print(s,x,y,c,b)            ' s=string, x,y obvious c=colour,b=background colour -1=transparent background
  repeat while byte[s][0]
    prtchr(byte[s][0],x,y,c,b)
    s++
    x+=8

PUB prtchr(ch,x,y,c,b) | f,xx,yy
  f:=font.GetPtrToFontTable+(ch<<3)
  repeat yy from 0 to 7
    repeat xx from 0 to 7
      if(byte[f][0]&(|<(7-xx)))
        plot(x+xx,y+yy,c)
      else
        if(b<>-1)
          plot(x+xx,y+yy,b)
    f++

PUB fatprint(s,x,y)            ' s=string, x,y obvious c=colour,b=background colour -1=transparent background
  repeat while byte[s][0]
    fatprtchr(byte[s][0]-32,x,y)
    s++
    x+=4

PUB fatprtchr(ch,x,y) | f,c,yy
  f:=@fatfont[ch<<4]
  repeat yy from 0 to 7
    c:=byte[f]&$0f
    plot(x  ,y,c)
    c:=byte[f++]>>4
    plot(x+1,y,c)
    c:=byte[f]&$0f
    plot(x+2,y,c)
    c:=byte[f++]>>4
    plot(x+3,y++,c)

PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1

PUB ms(Period)
  if Period                                    '1 mS
    waitcnt(_1mS * Period + cnt)

DAT

tvparams      long    0               'status
              long    1               'enable
              long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
              long    mode            'mode
              long    x_tiles         'hc
              long    y_tiles         'vc
              long    my_hx           'hx
VSyncFlag     long    0
nextline      long    0                        
disp_ptr      long    @data+$10
bordercolour  long    $02
              long    @palette+$10

palette       byte    $02,$07,$28,$8d,$ba,$1a,$db,$3d,$8f,$5f,$3f,$5b,$d8,$04,$02,$02

data          file    "propman.bit"

sprites       file    "propspr.bit"
SpriteXSZ     byte     6, 6, 6, 6, 6, 6, 4, 4, 4, 4, 4, 4, 4, 4, 8, 8
SpriteYSZ     byte     9, 9, 9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 8, 8,16,16

fatfont       file    "fatfont.chr"
